;078h =x


.model small
.386
.stack

.code
	prevISR  dd 0                       		      	
        floor    db 078h,078h,078h			        	
        cfloor   db 0      	        	                
	gotof	 db 0
        txt      db "Enter floor [q or Q for exit] : $"
	txt2	 db 12,10,"Floor already queued",12,10,"Enter floor: $"
        timeout  db 195
	 

start:

    
    	mov dx,0378h				;turn off relays..
    	xor al,al
    	out dx,al


    	mov   ax, 3508h		                ;get isr from 08h in vector table and store in es:bx
	int   21h                           	
	mov   WORD PTR prevISR, bx		
	mov   WORD PTR prevISR[2], es
  
 
 	push  ds					      
	push  cs				    	     
	pop   ds				    	      

	mov   dx, OFFSET getFloor           	;replace location 08h in vector table with procedure 
	mov   ax, 2508h		          	;pointed by ds:dx	
	int   21h

	pop   ds

    	mov ax,seg txt		
    	mov ds,ax
    	mov dx,offset txt			;print text
    	mov ah,9h
   	int 21h			                           		


   

read:      
	xor al,al
	mov ah,01h
	int 21h
	mov dl,al
	cmp dl,051h			;is key q/Q quit if true
	je  quit
	cmp dl,071h
	je  quit
	

	
	cmp dl,floor[0]			;check que for entered value
	je  read0
	cmp dl,floor[1]
	je read0
	cmp dl,floor[2]
	jne read1

read0:	mov ax,seg txt2				;print value already in que
	mov ds,ax
	mov dx,offset txt2
	mov ah,09h
	int 21h
	jmp read

	
read1:  mov al,floor[2]
	cmp al,078h
	jne read2
	mov floor[2],dl
	jmp read

read2:  mov al,floor[1]
	cmp al,078h
	jne read3
	mov floor[1],dl
	jmp read

read3:  
	mov al,floor[0]
	cmp al,078h
	jne read4
	mov floor[0],dl
read4:	jmp read


quit:  
 	
	mov   dx, WORD PTR prevISR		;restore procedure back to 08h in vector table
	mov   ds, WORD PTR prevISR[2]
	mov   ax, 2508h
	int   21h
	
 	
	
    	mov ah,4ch
	int 21h
	

getFloor proc 	far		
						
	cli						      	
	push dx							
	push ax

      mov al,timeout
      cmp al,250
      ja move1
      inc al
      mov timeout,al			;increment timeout if its less than 250(prevent overflow)



move1:  mov dx,0378h
	xor al,al
	in al,dx
	cmp al,0
	jne @0
	mov al,timeout
	cmp al,90
        jb  @0

	mov al,floor[2]
	cmp al,078h
	jne move2
	mov al,floor[1]
	mov floor[2],al
	mov al,floor[0]
	mov floor[1],al
	mov floor[0],078h
        jmp @0
	
move2:	mov floor[2],078h
	mov gotof,al
	cmp al,cfloor
   
   	je   @0
	jb   down1
	ja   up1


	
down1: 	mov dx,0378h
       	mov al,02h		;fire going down relay
       	out dx,al
       	jmp @0

up1:
	mov dx,0378h		;fire going up relay
	mov al,01h
	out dx,al


@0:
      	mov dx,0379h
	xor al,al
      	in al,dx
	and al,80h			
	cmp al,80h		;1st floor is got when bit 7 of status reg is low.
 	jne @1
	mov cfloor,30h	
	jmp @3

@1:	mov dx,0379h
	xor al,al
      	in al,dx
      	and al,20h		;2nd floor is got when bit 6 of status reg is low
	cmp al,00h
	jne @2
	mov cfloor,31h
	jmp @3

@2:   	mov dx,0379h
	xor al,al
      	in al,dx
      	and al,10h
	cmp al,00h		;3rd floor is got when bit 5 of status reg is low
	jne @4
	mov cfloor,32h
		
@3:	

	mov al,cfloor
	cmp gotof,al
	jne @4
	mov dx,0378h		;break relay and reset timeout.
	xor al,al
	mov timeout,al
	out dx,al
	
    
      

       
@4:	mov al, 20h		; i have finished using the service routine.. its required
	out 20h, al
        
	
	
	pop ax
	pop dx
		
	iret	

getFloor endp


	

end start 